<template>
  <div class="app-container">
    <!--工具栏-->
    <div class="head-container">
      <!-- 搜索 -->
      <el-input v-model="query.value" clearable placeholder="输入搜索内容" style="width: 200px;" class="filter-item" @keyup.enter.native="toQuery"/>
      <el-select v-model="query.type" clearable placeholder="类型" class="filter-item" style="width: 130px">
        <el-option v-for="item in queryTypeOptions" :key="item.key" :label="item.display_name" :value="item.key"/>
      </el-select>
      <el-button class="filter-item" size="mini" type="success" icon="el-icon-search" @click="toQuery">搜索</el-button>
      <!-- 新增 -->
      <div style="display: inline-block;margin: 0px 2px;">
        <el-button
          v-permission="['ADMIN','STASK_ALL','STASK_CREATE']"
          class="filter-item"
          size="mini"
          type="primary"
          icon="el-icon-plus"
          @click="add">新增</el-button>
      </div>
    </div>
    <!--表单组件-->
    <eForm ref="form" :is-add="isAdd"/>
    <!--表格渲染-->
    <el-table v-loading="loading" :data="data" size="small" style="width: 100%;">
      <el-table-column prop="name" label="任务名称"/>
      <el-table-column prop="tasktype" label="任务类型">
        <template slot-scope="scope">
          <div v-for="item in dicts" :key="item.id">
            <div v-if="scope.row.tasktype === item.value">{{ item.label }}</div>
          </div>
        </template>
      </el-table-column>
      <el-table-column prop="tasktime" label="任务时间">
        <template slot-scope="scope">
          <span>{{ getDayTime(scope.row) }}</span>
        </template>
      </el-table-column>
      <el-table-column prop="deviceid" label="控制器" min-width="110px;"/>
      <el-table-column prop="commond" label="指令信息"/>
      <el-table-column prop="wayinfo" label="支路开关信息" min-width="110px;"/>
      <el-table-column prop="valid" label="是否启用">
        <template slot-scope="scope">
          <el-tag :type="scope.row.valid === '1' ? 'warning' : 'success'">{{ scope.row.valid === '1' ? '已暂停' : '运行中' }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column prop="createTime" label="创建时间">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column v-if="checkPermission(['ADMIN','STASK_ALL','STASK_EDIT','STASK_DELETE'])" label="操作" width="350px" align="center">
        <template slot-scope="scope">
          <el-button v-permission="['ADMIN','STASK_ALL','STASK_EDIT']" size="mini" type="primary" @click="edit(scope.row)">编辑</el-button>
          <el-button v-permission="['ADMIN','JOB_ALL','JOB_EDIT']" style="margin-left: 3px" type="success" size="mini" @click="execute(scope.row.id)">执行</el-button>
          <el-button v-permission="['ADMIN','JOB_ALL','JOB_EDIT']" :type="scope.row.valid === '1' ? 'warning' : 'info'" style="margin-left: 3px" size="mini" @click="updateStatus(scope.row.id,scope.row.valid === '1' ? '恢复' : '暂停')">
            {{ scope.row.valid === '1' ? '恢复' : '暂停' }}
          </el-button>
          <el-popover
            v-permission="['ADMIN','STASK_ALL','STASK_DELETE']"
            :ref="scope.row.id"
            placement="top"
            width="180">
            <p>确定删除本条数据吗？</p>
            <div style="text-align: right; margin: 0">
              <el-button size="mini" type="text" @click="$refs[scope.row.id].doClose()">取消</el-button>
              <el-button :loading="delLoading" type="primary" size="mini" @click="subDelete(scope.row.id)">确定</el-button>
            </div>
            <el-button slot="reference" style="margin-left: 3px" type="danger" size="mini">删除</el-button>
          </el-popover>
        </template>
      </el-table-column>
    </el-table>
    <!--分页组件-->
    <el-pagination
      :total="total"
      :current-page="page + 1"
      style="margin-top: 8px;"
      layout="total, prev, pager, next, sizes"
      @size-change="sizeChange"
      @current-change="pageChange"/>
  </div>
</template>

<script>
import checkPermission from '@/utils/permission'
import initData from '@/mixins/initData'
import initDict from '@/mixins/initDict'
import { del, updateIsPause, execution } from '@/api/sTask'
import { parseTime } from '@/utils/index'
import eForm from './form'
export default {
  components: { eForm },
  mixins: [initData, initDict],
  data() {
    return {
      delLoading: false,
      queryTypeOptions: [
        { key: 'name', display_name: '任务名称' }
      ]
    }
  },
  created() {
    this.$nextTick(() => {
      this.init()
      this.getDict('tasktype')
    })
  },
  methods: {
    parseTime,
    checkPermission,
    beforeInit() {
      this.url = 'api/sTask'
      const sort = 'id,desc'
      this.params = { page: this.page, size: this.size, sort: sort }
      const query = this.query
      const type = query.type
      const value = query.value
      if (type && value) { this.params[type] = value }
      return true
    },
    getDayTime(row) {
      var tasktype = row.tasktype
      var tasktime = row.tasktime
      if (tasktype === '0') {
        return tasktime
      } else if (tasktype === '1') {
        return '每天' + tasktime.split(' ')[1]
      } else if (tasktype === '2') {
        var day = ((tasktime.split(' ')[0]).split('-'))[2]
        var ttime = '每月' + day + '日' + tasktime.split(' ')[1]
        return ttime
      } else if (tasktype === '3') {
        return this.getWeek(tasktime) + ' ' + tasktime.split(' ')[1]
      } else {
        return tasktime
      }
    },
    getWeek(time) {
      var str = ''
      var week = new Date(time).getDay()
      if (week === 0) {
        str = '周日'
      } else if (week === 1) {
        str = '周一'
      } else if (week === 2) {
        str = '周二'
      } else if (week === 3) {
        str = '周三'
      } else if (week === 4) {
        str = '周四'
      } else if (week === 5) {
        str = '周五'
      } else if (week === 6) {
        str = '周六'
      }
      return str
    },
    subDelete(id) {
      this.delLoading = true
      del(id).then(res => {
        this.delLoading = false
        this.$refs[id].doClose()
        this.dleChangePage()
        this.init()
        this.$notify({
          title: '删除成功',
          type: 'success',
          duration: 2500
        })
      }).catch(err => {
        this.delLoading = false
        this.$refs[id].doClose()
        console.log(err.response.data.message)
      })
    },
    add() {
      this.isAdd = true
      this.$refs.form.dialog = true
    },
    edit(data) {
      this.isAdd = false
      const _this = this.$refs.form
      _this.form = {
        id: data.id,
        name: data.name,
        tasktype: data.tasktype,
        tasktime: data.tasktime,
        deviceid: data.deviceid,
        commond: data.commond,
        wayinfo: data.wayinfo,
        valid: data.valid,
        userid: data.userid,
        createTime: data.createTime,
        updateTime: data.updateTime,
        nt: data.nt
      }
      _this.dialog = true
      this.$refs.form.loadByTaskid()
      this.$refs.form.getDafultFlg()
    },
    execute(id) {
      console.log(id, 'execute')
      execution(id).then(res => {
        this.$notify({
          title: '执行成功',
          type: 'success',
          duration: 2500
        })
      }).catch(err => {
        console.log(err.response.data.message)
      })
    },
    updateStatus(id, status) {
      console.log(id, status, 'updateStatus')
      updateIsPause(id).then(res => {
        this.init()
        this.$notify({
          title: status + '成功',
          type: 'success',
          duration: 2500
        })
      }).catch(err => {
        console.log(err.response.data.message)
      })
    }
  }
}
</script>

<style scoped>

</style>
